#!/bin/sh
. `dirname $0`/../../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

H264_ENC_VIDEONUMBER=`gst-inspect-1.0  | grep 264enc | awk '{print $2}'`
H264_ENC_VIDEONUMBER="${H264_ENC_VIDEONUMBER%?}"
echo "ENCODER Number = $H264_ENC_VIDEONUMBER"


echo "starting gstreamer with rgb Source ..."
echo "read 640x512, convert rgb to I420 with IPU-CSC, use i.MX6 vpu mpeg-4 codec and write in col_capture.avi"
echo "use IPU-CSC for lower CPU load"
echo "========================================================================================"
echo ""
echo "configure IPU/VPU with media_control"
echo "===================================="

echo "set skip value via v4l2-ctl"
v4l2-ctl -d $CAM_DEVICE --set-ctrl=skip_x=1
v4l2-ctl -d $CAM_DEVICE --set-ctrl=skip_y=1

media-ctl -r
media-ctl -V ''$CAM_ENTITY_NUMBER'0[fmt:'$CAM_COL_FMT'/640x512('$OFFSET_SENSOR')/1280x1024]'
media-ctl -V '"ipu0-csi0-sd":0[fmt:'$CAM_COL_FMT'/640x512]'
media-ctl -V '"ipu0-csi0-sd":1[fmt:'$CAM_COL_FMT'/640x512]'
#           Camera -> IPU0-CSI0-sd -> IPU0-CSI0-video (/dev/videoX)

echo ""
echo "start gstreamer, break with ctl-C"
echo "================================="

gst-launch-1.0 \
	v4l2src device=$IPU0_CSI0_DEVICE ! \
	i2c file=$(dirname $0)/set_skip2_shutter.txt show=0 dev=$CAM_DEVICE ! \
	video/x-raw,format=UYVY,width=640,height=512 ! \
	queue ! videoconvert ! $H264_ENC_VIDEONUMBER ! h264parse ! matroskamux ! \
	filesink location=col_capture.avi
	
echo "For show the saved stream, use VLC-Player"
echo ""
echo "if v4l2videoxh264enc not found, please update the gstreamer cache, type:"
echo "> rm $HOME/.cache/gstreamer-1.0/registry*"
echo "> gst-inspect-1.0"
echo ""
