#!/bin/sh
. `dirname $0`/../../func.sh

echo 0 > /sys/class/graphics/fbcon/cursor_blink

CAM_I2C_ADRESS_0="48"
CAM_I2C_ADRESS_1="5d"
IPU0_CSI0_DEVICE=$(media-ctl -e "ipu0-csi0-video")
IPU1_CSI1_DEVICE=$(media-ctl -e "ipu1-csi1-video")
CAM_DEVICE_0=$(media-ctl -e "mt9p031 2-00$CAM_I2C_ADRESS_0")
CAM_DEVICE_1=$(media-ctl -e "mt9p031 2-00$CAM_I2C_ADRESS_1")
CAM_ENTITY_NUMBER_0=`media-ctl -p | grep " mt9p031 2-00$CAM_I2C_ADRESS_0" | awk '{print $3}'`
CAM_ENTITY_NUMBER_1=`media-ctl -p | grep " mt9p031 2-00$CAM_I2C_ADRESS_1" | awk '{print $3}'`

echo ""
echo "IPU0_CSI0_DEVICE = $IPU0_CSI0_DEVICE"
echo "IPU1_CSI1_DEVICE = $IPU1_CSI1_DEVICE"
echo "CAM_DEVICE_0 = $CAM_DEVICE_0"
echo "CAM_DEVICE_1 = $CAM_DEVICE_1"
echo "CAM_ENTITY_NUMBER_0 = $CAM_ENTITY_NUMBER_0"
echo "CAM_ENTITY_NUMBER_1 = $CAM_ENTITY_NUMBER_1"
echo ""

echo "starting gstreamer with two GRAY Sources ..."
echo "read camera_0 from CSI0 and camera_1 from CSI1 with 2592 x 1944"
echo "write side by side to 5184x1944 Pixel, convert to jpg and write to mt9p031_bw_dual_image.jpg"
echo "============================================================================================"
echo ""
echo "configure IPU/VPU with media_control"
echo "===================================="

media-ctl -r
media-ctl -V ''$CAM_ENTITY_NUMBER_0'0[fmt:Y8/2592x1944 (16,54)/2592x1944]'
media-ctl -V '"ipu0-csi0-sd":0[fmt:Y8/2592x1944]'
media-ctl -V '"ipu0-csi0-sd":1[fmt:Y8/2592x1944]'
#           Camera -> IPU0-CSI0-sd -> IPU0-CSI0-video (/dev/videoX)   

media-ctl -V ''$CAM_ENTITY_NUMBER_1'0[fmt:Y8/2592x1944 (16,54)/2592x1944]'
media-ctl -V '"ipu1-csi1-sd":0[fmt:Y8/2592x1944]'
media-ctl -V '"ipu1-csi1-sd":1[fmt:Y8/2592x1944]'
#           Camera -> IPU0-CSI0-sd -> IPU0-CSI0-video (/dev/videoX)   


gst-launch-1.0 videomixer name=mix  sink_0::xpos=0 sink_0::ypos=0 sink_1::xpos=2592 sink_1::ypos=0 ! videoconvert ! jpegenc ! multifilesink location=mt9p031_bw_dual_image.jpg \
	v4l2src num-buffers=3 device=$IPU0_CSI0_DEVICE ! i2c addr=0x$CAM_I2C_ADRESS_0 file=`dirname $0`/../../register-settings-mt9p031.txt show=0 dev=$CAM_DEVICE_0 ! \
	video/x-raw,format=GRAY8,depth=8,width=2592,height=1944,framerate=1/1 ! videoconvert ! mix. \
	v4l2src num-buffers=3 device=$IPU1_CSI1_DEVICE ! i2c addr=0x$CAM_I2C_ADRESS_1 file=`dirname $0`/../../register-settings-mt9p031.txt show=0 dev=$CAM_DEVICE_1 ! \
	video/x-raw,format=GRAY8,depth=8,width=2592,height=1944,framerate=1/1 ! videoconvert ! mix. 
 