#!/bin/sh
. `dirname $0`/../../func.sh

echo 0 > /sys/class/graphics/fbcon/cursor_blink

CAM_I2C_ADRESS_0="48"
CAM_I2C_ADRESS_1="4c"
IPU0_CSI0_DEVICE=$(media-ctl -e "ipu0-csi0-video")
IPU1_CSI1_DEVICE=$(media-ctl -e "ipu1-csi1-video")
CAM_DEVICE_0=$(media-ctl -e "mt9v032 2-00$CAM_I2C_ADRESS_0")
CAM_DEVICE_1=$(media-ctl -e "mt9v032 2-00$CAM_I2C_ADRESS_1")
CAM_ENTITY_NUMBER_0=`media-ctl -p | grep " mt9v032 2-00$CAM_I2C_ADRESS_0" | awk '{print $3}'`
CAM_ENTITY_NUMBER_1=`media-ctl -p | grep " mt9v032 2-00$CAM_I2C_ADRESS_1" | awk '{print $3}'`

echo ""
echo "IPU0_CSI0_DEVICE = $IPU0_CSI0_DEVICE"
echo "IPU1_CSI1_DEVICE = $IPU1_CSI1_DEVICE"
echo "CAM_DEVICE_0 = $CAM_DEVICE_0"
echo "CAM_DEVICE_1 = $CAM_DEVICE_1"
echo "CAM_ENTITY_NUMBER_0 = $CAM_ENTITY_NUMBER_0"
echo "CAM_ENTITY_NUMBER_1 = $CAM_ENTITY_NUMBER_1"
echo ""


echo "starting gstreamer with two GRAY Sources ..."
echo "read camera_0 from CSI0 and camera_1 from CSI1 with 752 x 480"
echo "and write it side by side into two files 720x480 mt9v024_gray_csix_image.raw"
echo "============================================================================"
echo ""
echo "configure IPU/VPU with media_control"
echo "===================================="

media-ctl -r
media-ctl -V ''$CAM_ENTITY_NUMBER_0'0[fmt:Y8/752x480 (1,5)/752x480]'
media-ctl -V '"ipu0-csi0-sd":0[fmt:Y8/752x480]'
media-ctl -V '"ipu0-csi0-sd":1[fmt:Y8/752x480]'
#           Camera -> IPU0-CSI0-sd -> IPU0-CSI0-video (/dev/videoX)   

media-ctl -V ''$CAM_ENTITY_NUMBER_1'0[fmt:Y8/752x480 (1,5)/752x480]'
media-ctl -V '"ipu1-csi1-sd":0[fmt:Y8/752x480]'
media-ctl -V '"ipu1-csi1-sd":1[fmt:Y8/752x480]'
#           Camera -> IPU0-CSI0-sd -> IPU0-CSI0-video (/dev/videoX)   


echo ""
echo "start gstreamer, break with ctl-C"
echo "================================="


gst-launch-1.0 \
	v4l2src num-buffers=3 device=$IPU0_CSI0_DEVICE ! \
	i2c addr=0x$CAM_I2C_ADRESS_0 file=`dirname $0`/../../register-settings-mt9p031.txt show=0 dev=$CAM_DEVICE_0 ! \
	video/x-raw,format=GRAY8,depth=8,width=752,height=480 ! \
	multifilesink location=mt9v024_gray_csi0_image.raw
	
gst-launch-1.0 \
	v4l2src num-buffers=3 device=$IPU1_CSI1_DEVICE ! \
	i2c addr=0x$CAM_I2C_ADRESS_1 file=`dirname $0`/../../register-settings-mt9p031.txt show=0 dev=$CAM_DEVICE_1 ! \
	video/x-raw,format=GRAY8,depth=8,width=752,height=480 ! \
	multifilesink location=mt9v024_gray_csi1_image.raw

echo 1 > /sys/class/graphics/fbcon/cursor_blink